{"openapi":"3.1.0","info":{"title":"Ember Data API","summary":"Programmatic access to Ember's open electricity datasets","description":"# Quickstart\n\n## Introduction\n\nAn API for curated, consistent energy data.\nEmber’s API enables programmatic access to Ember’s electricity datasets.\nThis guide helps users get started with using the API.\n\nMachine-readable spec: [https://api.ember-energy.org/v1/openapi.json](https://api.ember-energy.org/v1/openapi.json)\n\n## Getting Started\n\nTo get set up with the API, follow these steps:\n\n### Register for API key\n\nSign up for an API key at [https://ember-energy.org/data/api/](https://ember-energy.org/data/api/)\n\n### Documentation\n\nEach endpoint is documented below with an brief explanation, and a link to the\ndataset methodology.\nGet a feel for the endpoints by clicking \"Try it out\" in the top right hand corner\nof any endpoint.\nYou then have to add your API key and any parameters you might want to add.\nClick Execute to run the query.\nThe docs will give you a printout of the query you can use outside the docs to\nfetch this data (see the Request URL box) as well as the response data that\nthe API returns (see Response body).\nThe url outlined in the Request URL box can be used in your desired python,\nR, js or other script to fetch data from the API.\nEndpoints through CURL are also available.\nCongratulations. You are now ready to use Ember’s API\n\n## Examples\n\n### python\n\n``` {python}\nimport requests\n\nmy_api_key = \"...\"\nbase_url = \"https://api.ember-energy.org\"\nquery_url = (\n  f\"{base_url}/v1/electricity-generation/yearly\"\n  + f\"?entity_code=BRA&is_aggregate_series=false&start_date=2000&api_key={my_api_key}\"\n)\n\nresponse = requests.get(query_url)\n\nif response.status_code == 200:\n    data = response.json()\n\n```\n\n### curl\n\n``` {bash}\nMY_API_KEY=\"...\"\ncurl \"https://api.ember-energy.org/v1/electricity-generation/yearly?entity_code=BRA&is_aggregate_series=false&start_date=2000&api_key=${MY_API_KEY}\"\n```\n\n## Endpoint Overview\n\n### Datasets\n\nDataset endpoints can be used to retrieve data on electricity generation,\npower sector emissions and more.\nThey are available for multiple temporal resolutions (currently yearly and monthly).\n\n### Options\n\nOptions endpoints can be used to retrieve possible options to use for\nparameters within the dataset endpoints, such as a list of all\ncountries, regions, fuels within the `/electricity-generation/monthly` endpoint.\nThe \"user_data_range\" key within the `stats` object will also show you the\nmin/max values for the available options.\n\nOptions can also be used for finding the available dates within a dataset.\n**This can be especially useful in understanding whether new data is available before querying the endpoint.**\nUse the `filter_name` of 'date' or 'year'. e.g.\n`http://api.ember-energy.org/v1/options/electricity-generation/monthly/date`\n\n## Query parameters\n\nQuery parameters with the exception of the api_key are optional.\nParameters can be used to filter the dataset and narrow down the response data.\nThe parameter names are consistent between datasets,\nbut can refer to different underlying variables.\nFor example, in the electricity-generation/yearly dataset,\nthe entity column refers to “Countries or regions”.\nThis is highlighted in the swagger docs (https://api.ember-energy.org/v1/docs).\n\n_Note: Parameters like entity, entity_code or series allow multiple values (e.g. entity_code=ARG,DEU,USA)_\n\n### `include_all_dates_value_range`\n\nBy default, dataset queries will include the range (min/max) of values in\nthe response data for any returned metric.\nThis can be found in the 'stats' object of the returned data.\nTo also include the range of values for all dates,\nrather than just dates selected in the query, set the parameter\n`include_all_dates_value_range` to true.\nThis can be useful when data from a narrower date range needs to be put in\ncontext of the full value range for a metric (e.g. the y-axis of a chart).\n\n### `is_aggregate_series`\n\nOther Renewables generation includes geothermal, tidal and wave generation.\nOther Fossil generation includes generation from oil and petroleum products,\nas well as manufactured gases and waste.\nHead to [Ember's datasets](https://ember-energy.org/data/#datasets)\nto view the methodology for each dataset.\n\n## Response Handling\n\nSuccessful responses will return the response code 200.\nUnsuccessful responses will return response codes 400-599, with the most common being:\n\n- 403: Incorrect authentication. Check your API key.\n- 404: Incorrect request. Check the URL.\n\n## Rate Limiting\n\nAt present, there are no rate limiting restrictions for the API.\n\n## Feedback and Questions\n\nIf you have any feedback or questions about our data,\nplease reach out to us at [data@ember-energy.org](mailto:data@ember-energy.org).\n\n## License and Attribution\n\nOur data is published using the CC-BY-4.0 license.\nAnyone is able to use our data for any purpose (personal, commercial, etc.).\nThe only requirements by this license are that:\n\n1. Ember is cited as the data source.\nE.g. 'Monthly electricity generation data, Ember'\n2. You may not add any additional legal/technological restrictions to the data.\n\nAdditional details on the terms of the license can be found at:\n","contact":{"name":"Ember Data Team","url":"https://ember-energy.org/contact/","email":"data@ember-energy.org"},"license":{"name":"CC-BY-4.0 (data)","url":"https://creativecommons.org/licenses/by/4.0/"},"version":"1.2.3"},"servers":[{"url":"https://api.ember-energy.org/v1","description":"Production"}],"paths":{"/carbon-intensity/yearly":{"get":{"tags":["Main routes"],"summary":"Get Yearly Carbon Intensity","description":"Get grid carbon intensity data at a yearly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/carbon-intensity/yearly?entity_code=AFG,BRA,DEU,ZAF&start_date=2020&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/yearly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getYearlyCarbonIntensity","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest year to return data for (YYYY)","default":"2000","title":"Start Date"},"description":"(Optional) The earliest year to return data for (YYYY)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest year to return data for (YYYY)","title":"End Date"},"description":"(Optional) The latest year to return data for (YYYY)"},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__1"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/carbon-intensity/monthly":{"get":{"tags":["Main routes"],"summary":"Get Monthly Carbon Intensity","description":"Get grid carbon intensity data at a monthly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/carbon-intensity/monthly?entity=Brazil&include_all_dates_value_range=true&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/monthly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getMonthlyCarbonIntensity","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest month to return data for (YYYY-MM)","default":"2000-01","title":"Start Date"},"description":"(Optional) The earliest month to return data for (YYYY-MM)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest month to return data for (YYYY-MM)","title":"End Date"},"description":"(Optional) The latest month to return data for (YYYY-MM)"},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__1"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/electricity-demand/yearly":{"get":{"tags":["Main routes"],"summary":"Get Yearly Demand","operationId":"getYearlyDemand","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest year to return data for (YYYY)","default":"2000","title":"Start Date"},"description":"(Optional) The earliest year to return data for (YYYY)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest year to return data for (YYYY)","title":"End Date"},"description":"(Optional) The latest year to return data for (YYYY)"},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__2"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/electricity-demand/monthly":{"get":{"tags":["Main routes"],"summary":"Get Monthly Demand","description":"Get electricity demand data at a monthly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/electricity-demand/monthly?entity_code=BRA,DEU,ZAF&start_date=2020-01&end_date=2020-12&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/monthly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getMonthlyDemand","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest month to return data for (YYYY-MM)","default":"2000-01","title":"Start Date"},"description":"(Optional) The earliest month to return data for (YYYY-MM)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest month to return data for (YYYY-MM)","title":"End Date"},"description":"(Optional) The latest month to return data for (YYYY-MM)"},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__3"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/power-sector-emissions/yearly":{"get":{"tags":["Main routes"],"summary":"Get Yearly Emissions","description":"Get power sector emissions data at a yearly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/power-sector-emissions/yearly?entity=G20&series=Coal,Gas&start_date=2000&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/yearly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getYearlyEmissions","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest year to return data for (YYYY)","default":"2000","title":"Start Date"},"description":"(Optional) The earliest year to return data for (YYYY)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest year to return data for (YYYY)","title":"End Date"},"description":"(Optional) The latest year to return data for (YYYY)"},{"name":"series","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. ","title":"Series"},"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. "},{"name":"is_aggregate_series","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels.","enum":["true","false"],"title":"Is Aggregate Series"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels."},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__4"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/power-sector-emissions/monthly":{"get":{"tags":["Main routes"],"summary":"Get Monthly Emissions","description":"Get power sector emissions data at a monthly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/power-sector-emissions/monthly?series=Fossil&start_date=2020-01&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/monthly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getMonthlyEmissions","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest month to return data for (YYYY-MM)","default":"2000-01","title":"Start Date"},"description":"(Optional) The earliest month to return data for (YYYY-MM)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest month to return data for (YYYY-MM)","title":"End Date"},"description":"(Optional) The latest month to return data for (YYYY-MM)"},{"name":"series","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. ","title":"Series"},"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. "},{"name":"is_aggregate_series","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels.","enum":["true","false"],"title":"Is Aggregate Series"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels."},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__4"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/electricity-generation/yearly":{"get":{"tags":["Main routes"],"summary":"Get Yearly Generation","description":"Get electricity generation data at a yearly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/electricity-generation/yearly?entity_code=BRA&is_aggregate_series=false&start_date=2000&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/yearly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getYearlyGeneration","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest year to return data for (YYYY)","default":"2000","title":"Start Date"},"description":"(Optional) The earliest year to return data for (YYYY)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest year to return data for (YYYY)","title":"End Date"},"description":"(Optional) The latest year to return data for (YYYY)"},{"name":"series","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. ","title":"Series"},"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. "},{"name":"is_aggregate_series","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels.","enum":["true","false"],"title":"Is Aggregate Series"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels."},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__5"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/electricity-generation/monthly":{"get":{"tags":["Main routes"],"summary":"Get Monthly Generation","description":"Get electricity generation data at a monthly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/electricity-generation/monthly?is_aggregate_entity=true&series=Solar,Wind&start_date=2020-01&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/monthly-electricity-data/)\n    within the 'Methodology - Ember Electricity Data' pdf.","operationId":"getMonthlyGeneration","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest month to return data for (YYYY-MM)","default":"2000-01","title":"Start Date"},"description":"(Optional) The earliest month to return data for (YYYY-MM)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest month to return data for (YYYY-MM)","title":"End Date"},"description":"(Optional) The latest month to return data for (YYYY-MM)"},{"name":"series","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. ","title":"Series"},"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. "},{"name":"is_aggregate_series","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels.","enum":["true","false"],"title":"Is Aggregate Series"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels."},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__5"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/options/{dataset}/{temporal_resolution}/{filter_name}":{"get":{"tags":["Available Options"],"summary":"Get Available Options","operationId":"getDatasetOptions","parameters":[{"name":"dataset","in":"path","required":true,"schema":{"type":"string","description":"A dataset to find options for (e.g. 'electricity-generation')","title":"Dataset"},"description":"A dataset to find options for (e.g. 'electricity-generation')"},{"name":"temporal_resolution","in":"path","required":true,"schema":{"type":"string","description":"The temporal resolution of the dataset (e.g. 'monthly')","title":"Temporal Resolution"},"description":"The temporal resolution of the dataset (e.g. 'monthly')"},{"name":"filter_name","in":"path","required":true,"schema":{"type":"string","description":"The name of the the parameter (e.g. entity, series)","title":"Filter Name"},"description":"The name of the the parameter (e.g. entity, series)"},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/installed-capacity/monthly":{"get":{"tags":["Main routes"],"summary":"Get Monthly Capacity","description":"Get installed wind and solar capacity in a monthly grain.\n    e.g.\n\n`https://api.ember-energy.org/v1/installed-capacity/monthly?is_aggregate_entity=false&series=Solar,Wind&start_date=2020-01&api_key=MY_API_KEY`\n    \n\nThe methodology of this dataset can be found on its [dataset page](https://ember-energy.org/data/monthly-wind-and-solar-capacity-data/)\n    within the 'Methodology - Monthly Wind and Solar Capacity Data' pdf.","operationId":"getMonthlyCapacity","parameters":[{"name":"entity","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`.","title":"Entity"},"description":"(Optional) [List of comma separated] country[s] or region[s] to return data for. Use the `options` endpoint to find the acceptable values. Note: some countries have a comma in their name. The comma can be escaped with a backslash (\\\\) to avoid being treated as a list of two countries. e.g.`entity=Saint Helena\\, Ascension and Tristan da Cunha,Saint Kitts and Nevis`queries the two entities `Saint Helena, Ascension and Tristan da Cunha` and `Saint Kitts and Nevis`."},{"name":"entity_code","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions.","title":"Entity Code"},"description":"(Optional) [List of comma separated] [3 letter ISO](https://www.iban.com/country-codes) country code[s] to return data for. Not used for regions."},{"name":"is_aggregate_entity","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions.","enum":["true","false"],"title":"Is Aggregate Entity"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated regions."},{"name":"start_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The earliest month to return data for (YYYY-MM)","default":"2016-01","title":"Start Date"},"description":"(Optional) The earliest month to return data for (YYYY-MM)"},{"name":"end_date","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) The latest month to return data for (YYYY-MM)","title":"End Date"},"description":"(Optional) The latest month to return data for (YYYY-MM)"},{"name":"series","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. ","title":"Series"},"description":"(Optional) [List of comma separated] electricity generation source[s] to return data for. Use the `options` endpoint to find the acceptable values. "},{"name":"is_aggregate_series","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels.","enum":["true","false"],"title":"Is Aggregate Series"},"description":"(Optional) Whether to return data only for aggregated / non-aggregated fuels.More detail is provided in the quickstart guide above about aggregate fuels."},{"name":"include_all_dates_value_range","in":"query","required":false,"schema":{"anyOf":[{"type":"boolean"},{"type":"null"}],"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above.","enum":["true","false"],"default":false,"title":"Include All Dates Value Range"},"description":"If true, summary statistics will also be calculated against the selected entity/series for the entire time-series. For more information, see the quickstart above."},{"name":"api_key","in":"query","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Api Key"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/app__models__common__model_to_response___locals___Response__6"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}}},"components":{"schemas":{"Capacity":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"series":{"type":"string","title":"Series"},"is_aggregate_series":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Series"},"capacity_gw":{"type":"number","title":"Capacity Gw"},"capacity_w_per_capita":{"type":"number","title":"Capacity W Per Capita"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","series","is_aggregate_series","capacity_gw","capacity_w_per_capita"],"title":"Capacity"},"CarbonIntensity":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"emissions_intensity_gco2_per_kwh":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Emissions Intensity Gco2 Per Kwh"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","emissions_intensity_gco2_per_kwh"],"title":"CarbonIntensity"},"DemandMonthly":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"demand_twh":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Demand Twh"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","demand_twh"],"title":"DemandMonthly"},"DemandYearly":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"demand_twh":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Demand Twh"},"demand_kwh_per_capita":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Demand Kwh Per Capita"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","demand_twh","demand_kwh_per_capita"],"title":"DemandYearly"},"Emissions":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"series":{"type":"string","title":"Series"},"is_aggregate_series":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Series"},"emissions_mtco2":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Emissions Mtco2"},"share_of_emissions_pct":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Share Of Emissions Pct"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","series","is_aggregate_series","emissions_mtco2","share_of_emissions_pct"],"title":"Emissions"},"Generation":{"properties":{"entity":{"type":"string","title":"Entity"},"entity_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Entity Code"},"is_aggregate_entity":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Entity"},"date":{"type":"string","title":"Date"},"series":{"type":"string","title":"Series"},"is_aggregate_series":{"anyOf":[{"type":"boolean"},{"type":"null"}],"title":"Is Aggregate Series"},"generation_twh":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Generation Twh"},"share_of_generation_pct":{"anyOf":[{"type":"number"},{"type":"null"}],"title":"Share Of Generation Pct"}},"type":"object","required":["entity","entity_code","is_aggregate_entity","date","series","is_aggregate_series","generation_twh","share_of_generation_pct"],"title":"Generation"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"type":"array","title":"Detail"}},"type":"object","title":"HTTPValidationError"},"Stats":{"properties":{"timestamp":{"type":"string","format":"date-time","title":"Timestamp"},"response_time_in_seconds":{"type":"number","title":"Response Time In Seconds"},"rate_limit":{"anyOf":[{"type":"integer"},{"type":"string"}],"title":"Rate Limit"},"number_of_records":{"type":"integer","title":"Number Of Records"},"query_parameters_used":{"additionalProperties":{"anyOf":[{"type":"string"},{"items":{},"type":"array"}]},"type":"object","title":"Query Parameters Used"},"available_metrics":{"items":{},"type":"array","title":"Available Metrics"},"query_value_range":{"anyOf":[{"type":"string"},{"additionalProperties":{"additionalProperties":{"anyOf":[{"type":"number"},{"type":"string"},{"type":"null"}]},"type":"object"},"type":"object"}],"title":"Query Value Range"},"query_all_dates_value_range":{"anyOf":[{"type":"string"},{"additionalProperties":{"additionalProperties":{"anyOf":[{"type":"number"},{"type":"string"},{"type":"null"}]},"type":"object"},"type":"object"}],"title":"Query All Dates Value Range"}},"type":"object","required":["timestamp","response_time_in_seconds","rate_limit","number_of_records","query_parameters_used","available_metrics","query_value_range","query_all_dates_value_range"],"title":"Stats"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"type":"array","title":"Location"},"msg":{"type":"string","title":"Message"},"type":{"type":"string","title":"Error Type"}},"type":"object","required":["loc","msg","type"],"title":"ValidationError"},"app__models__common__model_to_response___locals___Response__1":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/CarbonIntensity"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"CarbonIntensityResponse"},"app__models__common__model_to_response___locals___Response__2":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/DemandYearly"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"DemandYearlyResponse"},"app__models__common__model_to_response___locals___Response__3":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/DemandMonthly"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"DemandMonthlyResponse"},"app__models__common__model_to_response___locals___Response__4":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/Emissions"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"EmissionsResponse"},"app__models__common__model_to_response___locals___Response__5":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/Generation"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"GenerationResponse"},"app__models__common__model_to_response___locals___Response__6":{"properties":{"stats":{"$ref":"#/components/schemas/Stats"},"data":{"items":{"$ref":"#/components/schemas/Capacity"},"type":"array","title":"Data"}},"type":"object","required":["stats","data"],"title":"CapacityResponse"}}},"tags":[{"name":"Main routes"},{"name":"Subnational routes"}]}